unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    Label3: TLabel;
    SaveDialog1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
	 function  tran(src,dst:String) : Boolean ;
	 procedure tranSub0(var F1:TextFile;var f:Boolean;var s1,s2:String);
	 procedure tranSub(var F1:TextFile;var x,y,z:Double;var s1,s2:String);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// [N]
procedure TForm1.FormShow(Sender: TObject);
begin
	;
end;

// [I]
procedure TForm1.Button4Click(Sender: TObject);
begin
	close ;
end;

// [Q1]
procedure TForm1.Button1Click(Sender: TObject);
var
	fn : String ;
begin
	fn := Edit1.Text ;
   if not(FileExists(fn+'.dxf')) then fn := '' ;

	with OpenDialog1 do begin
		FileName := ExtractFileName(fn) ;
      InitialDir := ExtractFilePath(fn) ;
      if (Execute) then begin
         Edit1.Text := ChangeFileExt(FileName,'');
      end;
   end;
end;

// [Q2]
procedure TForm1.Button3Click(Sender: TObject);
var
	fn : String ;
begin
	fn := Edit2.Text ;
	with SaveDialog1 do begin
		FileName := ExtractFileName(fn) ;
      InitialDir := ExtractFilePath(fn) ;
      if (Execute) then begin
         Edit2.Text := ChangeFileExt(FileName,'');
      end;
   end;
end;

// [ϊ]
procedure TForm1.Button2Click(Sender: TObject);
var
	fn1,fn2 : String ;
begin
	fn1 := Edit1.Text ;
	fn2 := Edit2.Text ;
	// ̓`FbN
	if (fn1 = '') then begin
		MessageBeep(Word(-1));
      MessageDlg('ϊDXFt@Cw肵ĉ'
      	,mtWarning,[mbOk],0);
		Edit1.SetFocus ;
		exit ;
   end;
	if (fn2 = '') then begin
		MessageBeep(Word(-1));
      MessageDlg('ϊCSVt@Cw肵ĉ'
      	,mtWarning,[mbOk],0);
		Edit2.SetFocus ;
		exit ;
   end;
   if not(FileExists(fn1+'.dxf')) then begin
		MessageBeep(Word(-1));
      MessageDlg('w肵DXFt@C݂܂'
      	,mtWarning,[mbOk],0);
		Edit1.SetFocus ;
		exit ;
   end;

	if (tran(fn1+'.dxf',fn2)) then begin
      MessageDlg('ϊ܂I',mtInformation,[mbOk],0);
   end
   else begin
      MessageDlg('ϊo܂łI',mtWarning,[mbOk],0);
   end;
end;

// ϊ
//		in src:DXFt@C(gqL)
//			dst:oCSVt@C(gq)
//		our	:True: False:s
function TForm1.tran(src,dst:String) : Boolean ;
var
	F1,F2:TextFile ;
   fn : String ;
	OKflag,LPflag,Rflag : Boolean ;
   s1,s2 : String ;
   i1,j : Integer ;
   f , ff : Boolean ;
   x,y,z , x1,y1,z1 : Double ;
   ws : String ;
begin
	OKflag := True ;
	fn := dst + '.csv' ;
	try
		AssignFile(F1,src);
   	Reset(F1);
		try
			AssignFile(F2,fn);
   		Rewrite(F2);
         WriteLn(F2, '"X","Y","Z"');
         // ENTITIES܂œǂݔ΂
			LPflag := True;
			while(LPflag)do begin
         	ReadLn(F1,s1);	ReadLn(F1,s2);
            i1 := -1 ;
				if (s1 <> '') then Val(s1,i1,j);
            if (i1 = 2)and(AnsiPos('ENTITIES',AnsiUpperCase(s2)) > 0) then
            	LPflag := False ;
            if (i1 = 0)and(AnsiPos('EOF',AnsiUpperCase(s2)) > 0) then
            	LPflag := False ;	// ꉞ
            if EOF(F1) then
            	LPflag := False ;	// ꉞ
         end;
			// ENTITIESǂݎJn
			ff := False ;
         x1 := 0.0 ;
         y1 := 0.0 ;
         z1 := 0.0 ;
			LPflag := True;
			Rflag := True;
			while(LPflag)do begin
            if EOF(F1) then break ;	// ꉞ
				if Rflag then begin
	         	ReadLn(F1,s1);	ReadLn(F1,s2);
				end
            else
            	Rflag := True ;
	         i1 := -1 ;
				if (s1 <> '') then Val(s1,i1,j);
            if (i1 = 0)and(AnsiPos('EOF',AnsiUpperCase(s2)) > 0) then
            	LPflag := False ;	// ꉞ
				// |Cvf̏ꍇ̏
            if (i1 = 0)and(AnsiPos('POLYLINE',AnsiUpperCase(s2)) > 0) then begin
					tranSub0(F1,f,s1,s2);
               ff := True ;
					Rflag := False ;
					continue ;
            end;
            if (i1 = 0)and(AnsiPos('VERTEX',AnsiUpperCase(s2)) > 0) then begin
					tranSub(F1,x,y,z,s1,s2);
               ws := FloatToStr(x) + ',' ;
               ws := ws + FloatToStr(y) + ',' ;
               ws := ws + FloatToStr(z) ;
		         WriteLn(F2, ws);
					Rflag := False ;
               if (ff) then begin	// P_o
						x1 := x ;	y1 := y ;	z1 := z ;
                  ff := False ;
               end;
					continue ;
				end;
            if (i1 = 0)and(AnsiPos('SEQEND',AnsiUpperCase(s2)) > 0) then begin
					if (f) then begin		// Ă鎞͍ŌɑP_L^
         	      ws := FloatToStr(x1) + ',' ;
      	         ws := ws + FloatToStr(y1) + ',' ;
   	            ws := ws + FloatToStr(z1) ;
			         WriteLn(F2, ws);
               end;
               ws := '"","",""' ;
		         WriteLn(F2, ws);
				end;
			end;

			CloseFile(F2);
		except
			CloseFile(F2);
			OKflag := False ;
	   end;
		CloseFile(F1);
	except
		CloseFile(F1);
		OKflag := False ;
   end;

	if (OKflag) then
   	Result := True
   else begin
   	Result := False ;
		if (FileExists(fn)) then
      	DeleteFile(fn);
   end;
end;

// ϊƃTuiPOLYLINEj
//		in F1:̓t@C
//		out f : True:Ă False:ĂȂ
//			s1,s2 : ̗vf
procedure TForm1.tranSub0(var F1:TextFile;var f:Boolean;var s1,s2:String);
var
	LPflag : Boolean ;
	i1,i2,j : Integer ;
begin
	f := False ;
	try
		LPflag := True;
		while(LPflag)do begin
			if EOF(F1) then break ;	// ꉞ
			ReadLn(F1,s1);	ReadLn(F1,s2);
      	i1 := -1 ;
			if (s1 <> '') then Val(s1,i1,j);
   	   if (i1 = 0) then
				LPflag := False ;		// [vI

   	   if (i1 = 70) then begin
				i2 := 0 ;
      	   if (s2 <> '') then begin
         		Val(s2,i2,j);
            	if (j <> 0) then i2 := 0 ;
				end;
            if ((i2 and 1) > 0) then
            	f := True ;
			end;
      end;
   except
   	;
   end;
end;

// ϊƃTuiVERTEXj
//		in F1:̓t@C
//		out x,y,z : W
//			s1,s2 : ̗vf
procedure TForm1.tranSub(var F1:TextFile;var x,y,z:Double;var s1,s2:String);
var
	LPflag : Boolean ;
	i1,j : Integer ;
begin
	x := 0.0 ;
   y := 0.0 ;
   z := 0.0 ;
	try
		LPflag := True;
		while(LPflag)do begin
			if EOF(F1) then break ;	// ꉞ
			ReadLn(F1,s1);	ReadLn(F1,s2);
      	i1 := -1 ;
			if (s1 <> '') then Val(s1,i1,j);
   	   if (i1 = 0) then
				LPflag := False ;		// [vI

   	   if (i1 = 10) then begin
      	   if (s2 <> '') then begin
         		Val(s2,x,j);
            	if (j <> 0) then x := 0.0 ;
				end;
			end;
   	   if (i1 = 20) then begin
      	   if (s2 <> '') then begin
         		Val(s2,y,j);
            	if (j <> 0) then y := 0.0 ;
	         end;
			end;
	      if (i1 = 30) then begin
   	      if (s2 <> '') then begin
      	   	Val(s2,z,j);
         	   if (j <> 0) then z := 0.0 ;
	         end;
			end;
      end;
   except
   	;
   end;
end;

end.
